/*
 *	essai sur la vision interieur d'un batiment
 */

#version 3.7;

global_settings {
		ambient_light rgb <0.05, 0.05, 0.05>
		assumed_gamma 1.0
		max_trace_level 8
		}

/* system includes */
#include  "colors.inc"
#include  "woods.inc"
#include  "textures.inc"
#include  "stones.inc"
#include  "metals.inc"
#include  "golds.inc"
#include  "glass.inc"
#include  "transforms.inc"

/* my includes */
#include  "values.inc"
#declare  NormClock = clock/800;		/* XXX */

#include  "reperes.inc"
#include  "vaisselle.inc"
#include  "meubles.inc"
#include  "cubes.inc"				// added Sun 08 Jan 2023
#include  "lumieres.inc"
#include  "supports.inc"			// new Thu 22 Dec 2022
#include  "elements.inc"
#include  "grostrucs.inc"
#include  "bidules.inc"
#include  "decorations.inc"
// #include  "univers.inc"
#include  "jardin.inc"
#include  "steles.inc"
#include  "monster.inc"
#include  "rotonde.inc"
#include  "annexe.inc"
#include  "machine.inc"

// #include  "batiment.inc"

#include  "essais.inc"

/*    ======================================================    */
/*
 *	Ici, on place les trucs et les machins dans la scène
 */

#local E = 6.45;

object { Gros_Truc 						}
object { La_BouncingBall 	translate <-E, 0, -E>		}
object { La_Structure	 	translate < E, 0,  E>		}
object { Le_Machin_Spiraleux  	translate < E, 0, -E>		}
object { Forme_Exemple_1 rotate y*167	translate <-E, 0,  E>	}

object { Balise 		translate < 20, 0, 0>		}
object { Balise 		translate <-20, 0, 0>		}
object { Balise_Bleue		translate <0, 0,  20>		}
object { Balise_Bleue		translate <0, 0, -20>		}

/*    ======================================================    */

light_source { < 5, 13, -7>
		color Gray70
		fade_distance   FADE_D
		fade_power      FADE_P }

light_source { <-7, 5,  12>
		color Gray60
		fade_distance   FADE_D
		fade_power      FADE_P  }

light_source { <-9, 6, -9>
		color Gray60
		fade_distance   FADE_D
		fade_power      FADE_P  }

/*
 *	le sol
 */
cylinder  { <0, -100, 0>, <0, 0, 0>, 8
		pigment {checker White Tan*0.30 } scale 10 }

sky_sphere {
  pigment {
    gradient y
      color_map {
        [ 0.5  color CornflowerBlue*0.08 ]
        [ 1.0  color MidnightBlue*0.55 ]
        }
    scale 0.25
    rotate z*4
    // translate -1
    }
  emission rgb <0.4, 0.4, 1>
  }

/*    ======================================================    */

#local AngleCam = 38;

#local CK = 1.444 - (NormClock * 3.141592654 * 1.12);

#local E_Cam = 19.30 - (1.8 * Cos_010(NormClock));

#local CamX  = E_Cam * sin(CK);
#local CamY  = 0.17 + NormClock * 6.90;
#local CamZ  = E_Cam * cos(CK);
#local Pos_Cam = <CamX, CamY, CamZ>;

#local LatX  =  0.00;
#local LatY  =  1.20 - (NormClock * 0.33);
#local LatZ  =  0.00;
#local Pos_Lat = <LatX, LatY, LatZ>;

#local Pos_Rep = Interpolate(Pos_Cam, Pos_Lat, 0.75);
object { Marker scale 0.3333 translate (Pos_Rep + <0, -0.85, 0>) }

camera	{
	location	Pos_Cam
	look_at		Pos_Lat
	right		x*image_width/image_height
	angle 		AngleCam
/****
	#if ( mod(clock, 45) < 5 )
	  focal_point	Pos_Rep
	  aperture	0.70
	  blur_samples	60
	#end
*****/
	}

/*    ------------------------------------------------------    */
